mimamorukun/mimamorukun/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('status/', include('status.urls')),
    path('admin/', admin.site.urls),
]

mimamorukun/status/urls.py
from django.urls import path

from . import views

app_name = 'status' 

urlpatterns = [
    path('', views.login, name='login'),
    path('index/', views.index, name='index'),
    path('update/<int:member_pk>', views.upd, name='update'),
]

mimamorukun/status/models.py
from django.db import models
from django.utils import timezone
# Create your models here.


class Member(models.Model):
    PLACE_CHOICE = (
        ('HOME', '在宅'),
        ('MEJIRO', '目白台'),
        ('OOTE', '大手町'),
        ('DAYOFF','休暇'),
    )

    STATUS_CHOICE = (
        ('WORK', '勤務中'),
        ('LEAVE', '離席中'),
        ('LUNCH', '食事中'),
    )

    name = models.CharField(
        verbose_name='名前',
        max_length=200,
    )

    place = models.CharField(
        verbose_name='勤務場所',
        choices=PLACE_CHOICE,
        max_length=10,
        default='目白台',
    )

    status = models.CharField(
        verbose_name='勤務ステータス',
        choices=STATUS_CHOICE,
        max_length=10,
        default='勤務中',
    )

    #********************************************
    status_work = models.BooleanField(
        default=False,
    )

    status_home = models.BooleanField(
        default=False,
    )

    status_meeting = models.BooleanField(
        default=False,
    )

    status_lunch = models.BooleanField(
        default=False,
    )

    last_update_time = models.DateTimeField(
        default=timezone.now
    )

    def __str__(self):
        return self.name

mimamorukun/status/views.py
from django.shortcuts import render, redirect
from django.http import HttpResponse
from .models import Member
from django.utils import timezone

#ログインユーザーのプライマリーキー 　グローバル変数として宣言するとどのメソッドでも共通して使える。
global user_pk



#ログイン画面
def login(request):
    global user_pk
  
    #POSTメソッド＝ログイン画面でloginボタンを押したとき
    if request.method == "POST":
        username = request.POST['username']

        #ユーザーが存在する場合
        try:
            user = Member.objects.get(name=username)
            user_pk = user.pk
            return redirect('status:index')
          
        #ユーザーが存在しない場合
        except:
            return render(request, 'status/login.html', {'error':'ユーザーが見つかりません'})  
        
    #GETメソッド＝ログイン画面が呼び出されるとき
    return render(request, 'status/login.html')


#ホーム画面呼び出し
def index(request):
    member = Member.objects.order_by('id')
    return render(request, 'status/index.html', {'member': member})


#ステータス更新    (member_pkにはindex.htmlのmember.pkが引き渡される)
def upd(request, member_pk):
    global user_pk
  
    #更新対象が自分以外だったら更新しない。
    if member_pk != user_pk:
        member = Member.objects.order_by('id')
        return render(request, 'status/index.html', {'member': member, 'error':'!!自分以外のステータスは更新できません!!'})
    
    #更新対象が自分だったら更新。
    else:
        #pk(プライマリーキー)をもとにMemberテーブルから自分データを取得、tにわたす。
        t = Member.objects.get(pk=user_pk)
    
        # workボタンがクリックされた場合の処理
        if 'work' in request.POST:
            if t.status_work:
                t.status_work = 'False'
            else:
                t.status_work = 'True'
    
        # homeボタンがクリックされた場合の処理
        if 'home' in request.POST:
            if t.status_home:
                t.status_home = 'False'
            else:
                t.status_home = 'True'
    
        # meetingボタンがクリックされた場合の処理
        if 'meeting' in request.POST:
            if t.status_meeting:
                t.status_meeting = 'False'
            else:
                t.status_meeting = 'True'
    
        # lunchボタンがクリックされた場合の処理
        if 'lunch' in request.POST:
            if t.status_lunch:
                t.status_lunch = 'False'
            else:
                t.status_lunch = 'True'

        # 最終更新時刻を更新
        t.last_update_time = timezone.datetime.now()

        #save()でDBに反映される。
        t.save()
    
        return redirect('status:index')

mimamorukun/status/templates/status/index.html
<!DOCTYPE html>
<html>
{% load static %}
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>みまもる</title>
    <link href="https://use.fontawesome.com/releases/v5.6.1/css/all.css" rel="stylesheet">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" integrity="sha384-JcKb8q3iqJ61gNV9KGb8thSsNjpSL0n8PARn9HuZOnIxN0hoP+VmmDGMN5t9UJ0Z" crossorigin="anonymous">
    <link rel="stylesheet" href="{% static 'style.css' %}">
</head>

<body>
    <div class="container">
        <header>
            <h1>
                <td align="center">みまもる</td>
                <i class="fa fa-coffee"></i>
            </h1>
            <div id="ham-menu">
                <ul>
                    <li>勤怠状況</li>
                    <li><a href="https://coordinated-history-8015.glideapp.io" target="_blank">図書管理アプリ</a></li>
                    <li>メニュー3</li>
                </ul>
            </div>
            <div id="menu-background"></div>
        </header>
    </div>

    <hr>

    <div class="container-fluid">
            <h4>
                <p>Work Status</p>
            </h4>
    </div>
    
    <!-- 自分以外を更新しようとするとエラーメッセージ表示 -->
    {% if error %}
    <hr>
    {{ error }}
    {% endif %}

    <hr>
    <main　class="container">
    {% for member in member.all %}
        <h4>
            <div class="row">
                <p>
                  <div class="my-box col-1">
                    <form action="{% url 'status:update' member.pk %}" method="POST">
                      {% csrf_token %}
                      {% if member.status_work %}
                        <button type="submit" name="work" class="btn"><i class="fas fa-user-circle fa-2x"></i></button>
                      {% else %}
                        <button type="submit" name="work" class="btn"><i class="fas fa-user-circle fa-2x icon-gray"></i></button>
                      {% endif %}
                    </form>
                  </div>
                  <div class="my-box col-2">
                    <h5 class="name">{{ member.name }}</h5>
                  </div>
                  <div class="my-box col-3 align-left">
                    <form action="{% url 'status:update' member.pk %}" method="POST">
                      {% csrf_token %}
                      {% if member.status_home %}
                        <button type="submit" name="home" class="btn"><i class="fas fa-home"></i></button>
                      {% else %}
                        <button type="submit" name="home" class="btn"><i class="fas fa-home icon-gray"></i></button>
                      {% endif %}
                    </form>
                    <form action="{% url 'status:update' member.pk %}" method="POST">
                      {% csrf_token %}
                      {% if member.status_meeting %}
                        <button type="submit" name="meeting" class="btn"><i class="fas fa-users"></i></button>
                      {% else %}
                        <button type="submit" name="meeting" class="btn"><i class="fas fa-users icon-gray"></i></button>
                      {% endif %}
                    </form>
                    <form action="{% url 'status:update' member.pk %}" method="POST">
                      {% csrf_token %}
                      {% if member.status_lunch %}
                        <button type="submit" name="lunch" class="btn"><i class="fas fa-utensils"></i></button>
                      {% else %}
                        <button type="submit" name="lunch" class="btn"><i class="fas fa-utensils icon-gray"></i></button>
                      {% endif %}
                    </form>
                  </div>
                　 <div class="my-box col-4 align-left">
                    <h6>
                        <p align="left">最終更新時刻 :<class="last_update_time">{{ member.last_update_time }}</p>
                    </h6>
                  </div>
                  
                </p>
            </div>
        </h4>
    {% endfor %}
    </main>

    <hr>

    <div class="container">
        <footer>
            <p>&copy; MUIT</p>
        </footer>
    </div>
    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js" integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV" crossorigin="anonymous"></script>
</body>
</html>

mimamorukun/status/templates/status/login.html
<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" integrity="sha384-JcKb8q3iqJ61gNV9KGb8thSsNjpSL0n8PARn9HuZOnIxN0hoP+VmmDGMN5t9UJ0Z" crossorigin="anonymous">

    <title>ログイン画面</title>
  </head>
  <body>
  
    <form class="form-signin" method="POST" action=''>{% csrf_token %}
      <img class="mb-4" src="/docs/4.5/assets/brand/bootstrap-solid.svg" alt="" width="72" height="72">
      <h1 class="h3 mb-3 font-weight-normal">Please login</h1>
      
      {% if error %}
      {{ error }}
      {% endif %}

      <input type="text" id="inputname" class="form-control" name="username" placeholder="username" required autofocus>
      <div class="checkbox mb-3">
      <!-- 入力枠とボタンの間の余白 -->
      </div>
      <button class="btn btn-lg btn-primary btn-block" type="submit">login</button>
      <p class="mt-5 mb-3 text-muted">&copy; MUIT</p>
    </form>
    

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js" integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV" crossorigin="anonymous"></script>
  </body>
</html>